from time import time
from gmpy2 import mpz, floor, sqrt
import math

def pi_chudnovsky(one):
	#pi_chundnovsky(one) Calculates pi using the Chudnovsky algorithm to amount of digits inputted
	#Returns digits of pi as an integer.	
    k = mpz(1) 						#set the index k as mpz
    ak = mpz(one)					#initialize first term as 10**digits, as mpz
    a_sum = mpz(one)				#initialize the sum ak as 10**digits, as mpz
    b_sum = 0						#intialize bk
    C3div24 = 640320**3 // 24		#Preload a constant term
    while 1:
		#Get ak term using floor division
        ak *= -(6*k-5)*(2*k-1)*(6*k-1)
        ak //= k*k*k*C3div24
        #Get sum of a and b up to kth term
		a_sum += ak
        b_sum += k * ak
        k += 1
        if ak == 0:					#breaks if abs(ak) < k^3*C3div24
            break
	#Last expression that takes sum of series a and b and returns pi		
    total = 13591409*a_sum + 545140134*b_sum
    pie = mpz((426880*floor(sqrt(10005*one)*one)) // total)
    return pie

#returns pi with 10 to 10^7 digits, increasing by a factor of 10 each time
if __name__ == "__main__":
	for i in range(1,8):
		digits = 10**i
		one = 10**digits
		t = time()
		pie = pi_chudnovsky(one)
		print "Chud:", digits, "digits; time:", time() - t
		
# Chud: 10 digits; time: 0.0019998550415
# Chud: 100 digits; time: 0.0
# Chud: 1000 digits; time: 0.0
# Chud: 10000 digits; time: 0.00499987602234
# Chud: 100000 digits; time: 0.25200009346
# Chud: 1000000 digits; time: 26.8100001812
# Chud: 10000000 digits; time: 6020.74199986